/*
Copyright The CBI Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	v1alpha1 "github.com/containerbuilding/cbi/pkg/apis/cbi/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeBuildJobs implements BuildJobInterface
type FakeBuildJobs struct {
	Fake *FakeCbiV1alpha1
	ns   string
}

var buildjobsResource = schema.GroupVersionResource{Group: "cbi.containerbuilding.github.io", Version: "v1alpha1", Resource: "buildjobs"}

var buildjobsKind = schema.GroupVersionKind{Group: "cbi.containerbuilding.github.io", Version: "v1alpha1", Kind: "BuildJob"}

// Get takes name of the buildJob, and returns the corresponding buildJob object, and an error if there is any.
func (c *FakeBuildJobs) Get(name string, options v1.GetOptions) (result *v1alpha1.BuildJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(buildjobsResource, c.ns, name), &v1alpha1.BuildJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.BuildJob), err
}

// List takes label and field selectors, and returns the list of BuildJobs that match those selectors.
func (c *FakeBuildJobs) List(opts v1.ListOptions) (result *v1alpha1.BuildJobList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(buildjobsResource, buildjobsKind, c.ns, opts), &v1alpha1.BuildJobList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1alpha1.BuildJobList{}
	for _, item := range obj.(*v1alpha1.BuildJobList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested buildJobs.
func (c *FakeBuildJobs) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(buildjobsResource, c.ns, opts))

}

// Create takes the representation of a buildJob and creates it.  Returns the server's representation of the buildJob, and an error, if there is any.
func (c *FakeBuildJobs) Create(buildJob *v1alpha1.BuildJob) (result *v1alpha1.BuildJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(buildjobsResource, c.ns, buildJob), &v1alpha1.BuildJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.BuildJob), err
}

// Update takes the representation of a buildJob and updates it. Returns the server's representation of the buildJob, and an error, if there is any.
func (c *FakeBuildJobs) Update(buildJob *v1alpha1.BuildJob) (result *v1alpha1.BuildJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(buildjobsResource, c.ns, buildJob), &v1alpha1.BuildJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.BuildJob), err
}

// Delete takes name of the buildJob and deletes it. Returns an error if one occurs.
func (c *FakeBuildJobs) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(buildjobsResource, c.ns, name), &v1alpha1.BuildJob{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeBuildJobs) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(buildjobsResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &v1alpha1.BuildJobList{})
	return err
}

// Patch applies the patch and returns the patched buildJob.
func (c *FakeBuildJobs) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1alpha1.BuildJob, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(buildjobsResource, c.ns, name, data, subresources...), &v1alpha1.BuildJob{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1alpha1.BuildJob), err
}
