/*
Copyright The CBI Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by informer-gen. DO NOT EDIT.

package v1alpha1

import (
	time "time"

	cbi_v1alpha1 "github.com/containerbuilding/cbi/pkg/apis/cbi/v1alpha1"
	versioned "github.com/containerbuilding/cbi/pkg/client/clientset/versioned"
	internalinterfaces "github.com/containerbuilding/cbi/pkg/client/informers/externalversions/internalinterfaces"
	v1alpha1 "github.com/containerbuilding/cbi/pkg/client/listers/cbi/v1alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// BuildJobInformer provides access to a shared informer and lister for
// BuildJobs.
type BuildJobInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1alpha1.BuildJobLister
}

type buildJobInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewBuildJobInformer constructs a new informer for BuildJob type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewBuildJobInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredBuildJobInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredBuildJobInformer constructs a new informer for BuildJob type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredBuildJobInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options v1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.CbiV1alpha1().BuildJobs(namespace).List(options)
			},
			WatchFunc: func(options v1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.CbiV1alpha1().BuildJobs(namespace).Watch(options)
			},
		},
		&cbi_v1alpha1.BuildJob{},
		resyncPeriod,
		indexers,
	)
}

func (f *buildJobInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredBuildJobInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *buildJobInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&cbi_v1alpha1.BuildJob{}, f.defaultInformer)
}

func (f *buildJobInformer) Lister() v1alpha1.BuildJobLister {
	return v1alpha1.NewBuildJobLister(f.Informer().GetIndexer())
}
